####

from .lib.install.dependencies import install_tokenmixer_dependencies
install_tokenmixer_dependencies()

import glob
import inspect
import os
import shutil

from .nodes_for_ComfyUI.pythonscripts.MinitokenizerNode import MinitokenizerNode


NODE_CLASS_MAPPINGS = {
    MinitokenizerNode.NAME: MinitokenizerNode,
}

THIS_DIR=os.path.dirname(os.path.abspath(__file__))
DIR_DEV_JS=os.path.abspath(f'{THIS_DIR}/nodes_for_ComfyUI/javascripts')
DIR_PY=os.path.abspath(f'{THIS_DIR}/nodes_for_ComfyUI/pythonscripts')
DIR_WEB_JS=os.path.abspath(f'{THIS_DIR}/../../web/extensions/TokenMixer')
if not os.path.exists(DIR_WEB_JS):
    os.makedirs(DIR_WEB_JS)

shutil.copytree(DIR_DEV_JS, DIR_WEB_JS, dirs_exist_ok=True)

nodes=[]
NOT_NODES=['constants','log','utils']

__all__ = ['NODE_CLASS_MAPPINGS']

for file in glob.glob('*.py', root_dir=DIR_PY) + glob.glob('*.js', root_dir=DIR_DEV_JS):
    name = os.path.splitext(file)[0]
    if name not in nodes and name not in NOT_NODES and not name.startswith('_') and not name.startswith('base'):
        nodes.append(name)

